V3D.TorusZ=function(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight, R, N, r, n)
{ V3D.Object3D.call(this);
  this.Parent=aParentScene;
  this.ClassName="TorusZ";
  this.FrontColor=aFrontColor;
  this.BackColor=aBackColor;
  this.StrokeColor=aStrokeColor;
  this.StrokeWeight=aStrokeWeight;
  var s, x, y, z, dR, p, Theta, Phi, d=-1, M=(2*n-1)*(2*N-1)-d;
  for (s=0; s<M/2; s++)
  { this.Poly3D[s]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
    
    p=2*s+1;
    Theta=2*Math.PI*p/M;
    Phi=(2*N-1)*2*Math.PI*p/M;
    dR=r*Math.sin(Phi);
    z=r*Math.cos(Phi);
    x=(R+dR)*Math.sin(Theta);
    y=(R+dR)*Math.cos(Theta);
    this.Poly3D[s].AddPoint(x,y,z);
      
    p=2*s+(2*n-1)+2;
    Theta=2*Math.PI*p/M;
    Phi=(2*N-1)*2*Math.PI*p/M;
    dR=r*Math.sin(Phi);
    z=r*Math.cos(Phi);
    x=(R+dR)*Math.sin(Theta);
    y=(R+dR)*Math.cos(Theta);
    this.Poly3D[s].AddPoint(x,y,z);
      
    p=2*s+2*(2*n-1)+1;
    Theta=2*Math.PI*p/M;
    Phi=(2*N-1)*2*Math.PI*p/M;
    dR=r*Math.sin(Phi);
    z=r*Math.cos(Phi);
    x=(R+dR)*Math.sin(Theta);
    y=(R+dR)*Math.cos(Theta);
    this.Poly3D[s].AddPoint(x,y,z);
      
    p=2*s+(2*n-1);
    Theta=2*Math.PI*p/M;
    Phi=(2*N-1)*2*Math.PI*p/M;
    dR=r*Math.sin(Phi);
    z=r*Math.cos(Phi);
    x=(R+dR)*Math.sin(Theta);
    y=(R+dR)*Math.cos(Theta);
    this.Poly3D[s].AddPoint(x,y,z);
          
    this.Poly3D[s].Update();
    
  }    
}
V3D.TorusX=function(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight, R, N, r, n)
{ V3D.Object3D.call(this);
  this.Parent=aParentScene;
  this.ClassName="TorusX";
  this.FrontColor=aFrontColor;
  this.BackColor=aBackColor;
  this.StrokeColor=aStrokeColor;
  this.StrokeWeight=aStrokeWeight;
  var s, x, y, z, dR, p, Theta, Phi, d=-1;
  for (s=0; s<n*N-d; s++)
  { this.Poly3D[s]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);

    p=s;
    Theta=2*Math.PI*p/(n*N-d);
    Phi=2*Math.PI*p*N/(n*N-d);
    dR=r*Math.sin(Phi);
    z=r*Math.cos(Phi);
    x=(R+dR)*Math.sin(Theta);
    y=(R+dR)*Math.cos(Theta);
    this.Poly3D[s].AddPoint(z,x,y);
      
    p=s+1;
    Theta=2*Math.PI*p/(n*N-d);
    Phi=2*Math.PI*p*N/(n*N-d);
    dR=r*Math.sin(Phi);
    z=r*Math.cos(Phi);
    x=(R+dR)*Math.sin(Theta);
    y=(R+dR)*Math.cos(Theta);
    this.Poly3D[s].AddPoint(z,x,y); 
      
    p=s+n+1;
    Theta=2*Math.PI*p/(n*N-d);
    Phi=2*Math.PI*p*N/(n*N-d);
    dR=r*Math.sin(Phi);
    z=r*Math.cos(Phi);
    x=(R+dR)*Math.sin(Theta);
    y=(R+dR)*Math.cos(Theta);
    this.Poly3D[s].AddPoint(z,x,y);
      
    p=s+n;
    Theta=2*Math.PI*p/(n*N-d);
    Phi=2*Math.PI*p*N/(n*N-d);
    dR=r*Math.sin(Phi);
    z=r*Math.cos(Phi);
    x=(R+dR)*Math.sin(Theta);
    y=(R+dR)*Math.cos(Theta);
    this.Poly3D[s].AddPoint(z,x,y);   
      
    this.Poly3D[s].Update();
    
  }    
}